
(function (App, $) {

	  //'Router' is a name of the router class
      var Router = Backbone.Router.extend({

         //The 'routes' maps URLs with parameters to functions on your router
         routes: {
            "" : 'homeRender',
            "home" : 'homeRender',
            "dashboard" : 'dashboardRender'
         },

         //'The function 'myFunc' defines the links for the route on the browser
         homeRender: function () {
            $('#container').removeClass('active');
            setTimeout(function(){
               App.Helper.loadTemplate('home',{},'container',function(){
                  $('#container').addClass('active');
               });
            },500);
         },

         dashboardRender: function () {
            var self = this;
            $('#container').removeClass('active');

            setTimeout(function(){
               App.Helper.ajax('./www/data/list.txt',function(data){

                  for(var k in data){
                     data[k]["timeFormat"] = App.Helper.timeFormat(data[k]["time"]);
                  }
                  var obj = {"builds":data};
                  App.Helper.loadTemplate('dashboard',obj,'container',function(){
                  $('#container').addClass('active');
               });

               });
            },500);
         }

      });

      //'router' is an instance of the Router
      App.Router = new Router();

      //Start listening to the routes and manages the history for bookmarkable URL's
      Backbone.history.start();

})(window.App = window.App || {}, jQuery, undefined);