
(function (App, $) {

	 var view = Backbone.View.extend({
	  // el - stands for element. Every view has an element associated with HTML content, will be rendered.
	  el: '#container',
	  // It's the first function called when this view is instantiated.
	  initialize: function(){
	    //this.render();
	  },
	  events: {
			"click .e-build": "loadDetails"
		},
		 loadDetails: function(e){
		 	var self = this;
		 	if($(e.currentTarget).hasClass('Pending') || $(e.currentTarget).hasClass('Running')){
		 		return;
		 	}

		 	var id = $(e.currentTarget).data('id');

		 	if($('.build-detail').data('id')==id){
		 		return;
		 	}

		 	$('.e-build').removeClass('active');
		 	$(e.currentTarget).addClass('active');

		 	$('.build-detail-container').removeClass('active');
		 	$('.build-detail').slideUp(function(){
		 		
		 	});
	 		
			App.Helper.ajax('./www/data/data-' + id + '.txt',function(data){
               
               $('.build-detail').remove();

               data["timeFormat"] = App.Helper.timeFormat(data["time"]);
               data["buildTimeFormat"] = App.Helper.timeFormat(data["insights"]["buildTime"]);

               var obj = {"build":data};
               App.Helper.loadTemplate('detail',obj,'build-' + id,function(){
               	$('#build-' + id).addClass('active');
	               	setTimeout(function(){
	               		self.fillCodeCovered();
	               		self.drawChartPie();
	               	},200);
               });
			});
		 },
		 fillCodeCovered : function(){

		 	$('.data-covered-fill').each(function(){
		 		var percentage = $(this).data('covered');
		 		$(this).css('width',percentage + '%');
		 		if(percentage<50){
		 			$(this).next().addClass('nagative');
		 			$(this).next().next().addClass('nagative');
		 		}
		 	});
		 },
		 drawChartPie: function(){
		 	$('.chart-pie').each(function(){
		 		var passed = $(this).data('passed');
		 		var failed = $(this).data('failed');
		 		var id = $(this).data('id');

		 		var total = passed + failed;
		 		var passPercentage = Math.round(passed/(total/100));
		 		var failPercentage = 100 - passPercentage;
		 			$(this).next().find('.chart-percentage-completed').html(passPercentage + '%');





		 			var labelElements = [passed,failed];
		 			var percentElements = [passPercentage,failPercentage];
                    var colorElements = ['#74AC51','#EA7E41'];
 
                    var canvas = document.getElementById(id);
                    var context = canvas.getContext("2d");
 
 					canvas.height = canvas.width;

                    var centerX = canvas.width / 2;
                    var centerY = canvas.height / 2;
                    var radius = 100;
 
                    context.beginPath();
                    var endAngle = 2 * Math.PI
 
                    var lastAngle = 0;
                    var pieTotal = 0;
 
                    for (var i = 0; i < percentElements.length; i++) {
                        var percent = percentElements[i];
                        var color = colorElements[i];

                        pieTotal += labelElements[i];
 
                        var currentSegment = endAngle * (percent/100);
                        var currentAngle = currentSegment + lastAngle;
 
                        context.beginPath();
                        context.moveTo(centerX, centerY)
                        context.arc(centerX, centerY, radius, lastAngle, currentAngle, false);
                        context.closePath();
 
                        lastAngle = lastAngle + currentSegment;
 
                        context.fillStyle = color;
                        context.fill();
 
                        if (this.segmentMode) {
                            context.lineWidth = 3;
                            context.strokeStyle = '#cccccc';
 
                        }else {
                            context.lineWidth = 3;
                            context.strokeStyle = '#ffffff';
 
                        }
                        context.stroke();
                        context.fill();

                    }
                    if (this.segmentMode) {
 
                        context.beginPath();
                        context.fillStyle = '#cccccc';
                        context.arc(centerX, centerY, radius - 20, 0, 2 * Math.PI, false);
                        context.fill();
                    }


                    // draw label
                     var hheight = canvas.height / 2;
                     var hwidth = canvas.width / 2;
                     var lastend = 0;


                     for (var i = 0; i < percentElements.length; i++) {
                     	var label = labelElements[i];
                     radius = radius / 1.5;
					var endAngle = lastend + (Math.PI*(label/pieTotal));
					var setX = hwidth + Math.cos(endAngle) * radius;
					var setY = hheight + Math.sin(endAngle) * radius;
					context.fillStyle = "#000000";
					var fontSize = Math.floor(canvas.height / 25);
					context.font = fontSize + "pt Helvetica";
					context.fillText(label,setX,setY);

					
		//			ctx.lineTo(hwidth,hheight);
					//ctx.fill(); //uncomment for debugging
					
					lastend += Math.PI*2*(label/pieTotal);

				}






		 	});
		 }
	});

	App.View.dashboard = new view();

})(window.App = window.App || {}, jQuery, undefined);