var compressor = require('node-minify');
var fs = require('fs');
var exec = require('child_process').exec;
var conf = require('./conf');


var rootPath = __dirname.split('/');
rootPath.pop();
rootPath = rootPath.join('/') + '/';



var globalJs = [
  
  //including lib files
  rootPath + 'js/lib/jquery-2.1.3.min.js',
  rootPath + 'js/lib/underscore-min.js',
  rootPath + 'js/lib/backbone-min.js',


  //including helper files
  rootPath + 'js/helper/helper.js',


  //including view files
  rootPath + 'js/views/home.js',
  rootPath + 'js/views/dashboard.js',

  //including router files
  rootPath + 'js/router.js',

];


// Only concatenation of files (no compression) 
compressor.minify({
    compressor: 'no-compress',
    input: globalJs,
    output: rootPath + 'js/global.js',
    callback: function(err, min){
      if(err){
        console.log(err);
        return;
      }
      console.log(rootPath + 'js/global.js'); 
    }
});


if(conf.jsMinify==true)
{
  // Using Google Closure 
  compressor.minify({
      compressor: 'gcc',
      input: rootPath + 'js/global.js',
      output: rootPath + 'js/min/global_min.js',
      callback: function(err, min){
        if(err){
          console.log(err);
          return;
        }
        console.log('global.js ---> global_min.js');
      }
  });

}

var lessFile = 'main.less';
exec("lessc " + rootPath + "less/" + lessFile + " " + rootPath + "css/" + lessFile.replace('.less','.css'), function (error, stdout, stderr) {
  if(error){
    console.log(error);
    return;
  }
  console.log(lessFile + ' ---> ' + lessFile.replace('.less','.css'));
  if(conf.cssMinify==true){
     compressor.minify({
        compressor: 'yui-css',
        input: rootPath + 'css/' + lessFile.replace('.less','.css'),
        output: rootPath + 'css/min/' + lessFile.replace('.less','_min.css'),
        callback: function(err, min){
          if(err){
            console.log(err);
            return;
          }
          console.log(lessFile.replace('.less','.css') + ' ---> ' + lessFile.replace('.less','_min.css'));
        }
    });
  }

});
 
if(conf.cssMinify==true){

  exec("cp -r " + rootPath + "css/fonts/* " + rootPath + "css/min/fonts/", function (error, stdout, stderr) {
    if(error){
      console.log(error);
      return;
    }
  });
}